"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ExitQuestionnaireInjectCancer(ProtocolElement):
    """
    Record for cancer exit questionnaire injection as part of the data
    intake for CVA
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "cancerGermlineExitQuestionnaires",
        "cancerSomaticExitQuestionnaires",
        "cancercaseLevelQuestions",
        "metadata",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import cva as cva_1_3_0
        from protocols.protocol_7_2 import reports as reports_6_0_1

        return {
            "cancerGermlineExitQuestionnaires": cva_1_3_0.CancerGermlineVariantLevelQuestionnaire,
            "cancerSomaticExitQuestionnaires": cva_1_3_0.CancerSomaticVariantLevelQuestionnaire,
            "cancercaseLevelQuestions": reports_6_0_1.CancerCaseLevelQuestions,
            "metadata": cva_1_3_0.InjectionMetadata,
            "otherActionableVariants": reports_6_0_1.AdditionalVariantsQuestions,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import cva as cva_1_3_0
        from protocols.protocol_7_2 import reports as reports_6_0_1

        return {
            "org.gel.models.cva.avro.CancerGermlineVariantLevelQuestionnaire": cva_1_3_0.CancerGermlineVariantLevelQuestionnaire,
            "org.gel.models.cva.avro.CancerSomaticVariantLevelQuestionnaire": cva_1_3_0.CancerSomaticVariantLevelQuestionnaire,
            "org.gel.models.report.avro.CancerCaseLevelQuestions": reports_6_0_1.CancerCaseLevelQuestions,
            "org.gel.models.cva.avro.InjectionMetadata": cva_1_3_0.InjectionMetadata,
            "org.gel.models.report.avro.AdditionalVariantsQuestions": reports_6_0_1.AdditionalVariantsQuestions,
            "org.gel.models.cva.avro.ExitQuestionnaireInjectCancer": cva_1_3_0.ExitQuestionnaireInjectCancer,
        }

    __slots__ = [
        "cancerGermlineExitQuestionnaires",
        "cancerSomaticExitQuestionnaires",
        "cancercaseLevelQuestions",
        "metadata",
        "additionalComments",
        "otherActionableVariants",
    ]

    def __init__(
        self,
        cancerGermlineExitQuestionnaires,
        cancerSomaticExitQuestionnaires,
        cancercaseLevelQuestions,
        metadata,
        additionalComments=None,
        otherActionableVariants=None,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_3_0.ExitQuestionnaireInjectCancer model.

        :param cancerGermlineExitQuestionnaires:
            Germline somatic exit questionnaire
        :type cancerGermlineExitQuestionnaires: list[CancerGermlineVariantLevelQuestionnaire]
        :param cancerSomaticExitQuestionnaires:
            Cancer somatic exit questionnaire
        :type cancerSomaticExitQuestionnaires: list[CancerSomaticVariantLevelQuestionnaire]
        :param cancercaseLevelQuestions:
            Case level questions
        :type cancercaseLevelQuestions: CancerCaseLevelQuestions
        :param metadata:
            Metadata on the report events in the clinical report
        :type metadata: InjectionMetadata
        :param additionalComments:
            Please enter any additional comments you may have about the case here.
        :type additionalComments: None | str
        :param otherActionableVariants:
            Other actionable variants or entities.         Please provide other
            (potentially) actionable entities: e.g domain 3 small
            variants,         SV/CNV, mutational signatures,
            mutational burden
        :type otherActionableVariants: None | list[AdditionalVariantsQuestions]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.3.0"
